<?php

$start = microtime();




require_once 'ipap-config.php';
require_once $path_lib.'ipap-functions.php';
require_once $path_lib.'template.php';
require_once $path_lib.'class.dbtxt.php';
$db = new dbtxt;


$cache_life = intval($cache_life * 60); // convert from minutes to seconds


/* =========================================================================
    //! display a folder/album
========================================================================= */
if (  isset($_GET['a'])  ) {



    $a = $_GET['a']; // error checking for $a should be here
    $a = strip_tags($a);

    if (isset($_GET['i'])) {
    	$i = intval($_GET['i']);
    } else {
    	$i = '';
    }





    $tpl = & new CachedTemplate('', 'album'.$a.$i, $cache_life);

    if(!($tpl->is_cached())) {


        // ****************** error checking for wrong sanitized name & visible
        // load album db
        $db->open($path_db.$db_albums, 0);
        $res = $db->select('sanitized_name', $a);
        $db->close();

        if (count($res) < 1) { // no such album
            header('Location:'.$gallery_url);
            exit;
        } elseif ($res[0]['visible'] != 1 && !$allow_view_hidden) { // hidden gallery & allow_view_hidden not allowed!
            header('Location:'.$gallery_url);
            exit;
        }



        $tpl->set('timestamp', date('r'));
        $tpl->set('ipap_version', $ipap_version);

        $tpl->set('site_name', $site_name);
        $tpl->set('site_url', $site_url);
        $tpl->set('gallery_name', $gallery_name);
        $tpl->set('gallery_url', $gallery_url);
        $tpl->set('thumbnail_size', $thumbnail_size);

        // album listing
        $album_list = @get_album_list();
        $tpl->set('albums', $album_list);

        // thumbnails for this album
        $thumbnail_list = @get_thumbnail_list($a);
        $tpl->set('thumbnails', $thumbnail_list);

        // info for this album
        $album_info = @get_album_info($a);
        $tpl->set('current_album', $album_info);


        if (strlen($i) > 0) {
            if (!@get_current_photo($a, $i)) { // you're guessing an id, get out!
                header('Location:'.$gallery_url);
                exit;
            } else {
                $current_photo = @get_current_photo($a, $i);
            }
        } else { // no id, so use the cover
            $use_i = @get_cover_id($a);
            $current_photo = @get_current_photo($a, $use_i);
        }

        $tpl->set('current_photo', $current_photo);


    }



    echo $tpl->fetch_cache('ipap-album.tpl.php');












/* =========================================================================
    //! gallery front page display
========================================================================= */
} elseif (  !isset($_GET['a'])  ) {
	// index display




    $tpl = & new CachedTemplate('', 'gallery', $cache_life);

    if(!($tpl->is_cached())) {


        $tpl->set('timestamp', date('r'));
        $tpl->set('ipap_version', $ipap_version);

        $tpl->set('site_name', $site_name);
        $tpl->set('site_url', $site_url);
        $tpl->set('gallery_name', $gallery_name);
        $tpl->set('gallery_url', $gallery_url);
        $tpl->set('thumbnail_size', $thumbnail_size);

        $album_list = @get_album_list();
        $tpl->set('albums', $album_list);


    }

    echo $tpl->fetch_cache('ipap-gallery.tpl.php');





}


$end = microtime();
if ($ipap_show_timer) {
    echo 'Debug info: output in '.microtime_diff($end,$start).' seconds.';
}


?>