<?php
/* 
2004-06-10 20:40:30
*/

function check_file_type($img_path)
{
	global $allowed_img_type;

    $info = getimagesize($img_path);
    if ( in_array($info['2'], $allowed_img_type) ) {
    	return true;
    } else {
    	return false;
    }
}









function sanitize_title($title) {
    $title = strtolower($title);
    $title = preg_replace('/&.+?;/', '', $title); // kill entities
    $title = preg_replace('/[^a-z0-9 _-]/', '', $title);
    $title = preg_replace('/\s+/', ' ', $title);
    $title = str_replace(' ', '-', $title);
    $title = preg_replace('|-+|', '-', $title);
    $title = trim($title, '-');

    return $title;
}








function auto_thumbnail($img)
{
    global $thumbnail_quality, $thumbnail_size, $path_photos, $thumbnail_prefix;

    $image_path = '../'.$path_photos.$img;

    $size = getimagesize($image_path);


    if ($size[0] > $size[1]) {
        // c
        $c_src_y = 0;
        $c_src_x = intval(($size[0] - $size[1])/2);

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[1], $size[1]);
        imagejpeg($c_thumb, '../'.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);


    } elseif ($size[0] < $size[1]) {
        // c
        $c_src_y = intval(($size[1] - $size[0])/2);
        $c_src_x = 0;

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
        imagejpeg($c_thumb, '../'.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);


    } elseif ($size[0] == $size[1]) {
        // c
        $c_src_y = 0;
        $c_src_x = 0;

        $src_img = imagecreatefromjpeg($image_path); // make 'connection' to image

        // center thumbnail
        $c_thumb = imagecreatetruecolor($thumbnail_size, $thumbnail_size);
        imagecopyresampled($c_thumb, $src_img, 0, 0, $c_src_x ,$c_src_y, $thumbnail_size, $thumbnail_size, $size[0], $size[0]);
        imagejpeg($c_thumb, '../'.$path_photos.$thumbnail_prefix.$img, $thumbnail_quality);
        imagedestroy($c_thumb);

        imagedestroy($src_img);

    }


	return 1;
}










function reformat_exif_date($exif_date)
{
	$exif_date = trim($exif_date);
    $exif_date = substr($exif_date, 0, 4).'-'.substr($exif_date, 5, 2).'-'.substr($exif_date, 8, 2).' '.substr($exif_date, 11, 2).':'.substr($exif_date, 14, 2).':'.substr($exif_date, 17, 2);
    return $exif_date;
}







function wpautop($pee, $br = 1)
{   // taken from wordpress

	$pee = $pee . "\n"; // just to make things a little easier, pad the end
	$pee = preg_replace('|<br />\s*<br />|', "\n\n", $pee);
	// Space things out a little
	$pee = preg_replace('!(<(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)!', "\n$1", $pee); 
	$pee = preg_replace('!(</(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])>)!', "$1\n", $pee);
	$pee = str_replace(array("\r\n", "\r"), "\n", $pee); // cross-platform newlines 
	$pee = preg_replace("/\n\n+/", "\n\n", $pee); // take care of duplicates
	$pee = preg_replace('/\n?(.+?)(?:\n\s*\n|\z)/s', "\t<p>$1</p>\n", $pee); // make paragraphs, including one at the end 
	$pee = preg_replace('|<p>\s*?</p>|', '', $pee); // under certain strange conditions it could create a P of entirely whitespace 
    $pee = preg_replace('!<p>\s*(</?(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*</p>!', "$1", $pee); // don't pee all over a tag
	$pee = preg_replace("|<p>(<li.+?)</p>|", "$1", $pee); // problem with nested lists
	$pee = preg_replace('|<p><blockquote([^>]*)>|i', "<blockquote$1><p>", $pee);
	$pee = str_replace('</blockquote></p>', '</p></blockquote>', $pee);
	$pee = preg_replace('!<p>\s*(</?(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)!', "$1", $pee);
	$pee = preg_replace('!(</?(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*</p>!', "$1", $pee); 
	if ($br) $pee = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $pee); // optionally make line breaks
	$pee = preg_replace('!(</?(?:table|thead|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|math|p|h[1-6])[^>]*>)\s*<br />!', "$1", $pee);
	$pee = preg_replace('!<br />(\s*</?(?:p|li|div|dl|dd|dt|th|pre|td|ul|ol)>)!', '$1', $pee);
	$pee = preg_replace('!(<pre.*?>)(.*?)</pre>!ise', " stripslashes('$1') .  clean_pre('$2')  . '</pre>' ", $pee);
	
	return $pee; 
}



function wptexturize($text)
{  // taken from wordpress

	$output = '';
	// Capture tags and everything inside them
	$textarr = preg_split("/(<.*>)/Us", $text, -1, PREG_SPLIT_DELIM_CAPTURE);
	$stop = count($textarr); $next = true; // loop stuff
	for ($i = 0; $i < $stop; $i++) {
		$curl = $textarr[$i];

		if (isset($curl{0}) && '<' != $curl{0} && $next) { // If it's not a tag
			$curl = str_replace('---', '&#8212;', $curl);
			$curl = str_replace('--', '&#8211;', $curl);
			$curl = str_replace("...", '&#8230;', $curl);
			$curl = str_replace('``', '&#8220;', $curl);

			// This is a hack, look at this more later. It works pretty well though.
			$cockney = array("'tain't","'twere","'twas","'tis","'twill","'til","'bout","'nuff","'round");
			$cockneyreplace = array("&#8217;tain&#8217;t","&#8217;twere","&#8217;twas","&#8217;tis","&#8217;twill","&#8217;til","&#8217;bout","&#8217;nuff","&#8217;round");
			$curl = str_replace($cockney, $cockneyreplace, $curl);

			$curl = preg_replace("/'s/", '&#8217;s', $curl);
			$curl = preg_replace("/'(\d\d(?:&#8217;|')?s)/", "&#8217;$1", $curl);
			$curl = preg_replace('/(\s|\A|")\'/', '$1&#8216;', $curl);
			$curl = preg_replace('/(\d+)"/', '$1&Prime;', $curl);
			$curl = preg_replace("/(\d+)'/", '$1&prime;', $curl);
			$curl = preg_replace("/(\S)'([^'\s])/", "$1&#8217;$2", $curl);
			$curl = preg_replace('/(\s|\A)"(?!\s)/', '$1&#8220;$2', $curl);
			$curl = preg_replace('/"(\s|\Z)/', '&#8221;$1', $curl);
			$curl = preg_replace("/'([\s.]|\Z)/", '&#8217;$1', $curl);
			$curl = preg_replace("/\(tm\)/i", '&#8482;', $curl);
			$curl = preg_replace("/\(c\)/i", '&#169;', $curl);
			$curl = preg_replace("/\(r\)/i", '&#174;', $curl);
			$curl = str_replace("''", '&#8221;', $curl);
			
			$curl = preg_replace('/(d+)x(\d+)/', "$1&#215;$2", $curl);

		} elseif (strstr($curl, '<code') || strstr($curl, '<pre') || strstr($curl, '<kbd' || strstr($curl, '<style') || strstr($curl, '<script'))) {
			// strstr is fast
			$next = false;
		} else {
			$next = true;
		}
		$output .= $curl;
	}
	return $output;
}




function show_visible($album_list)
{
    $visible_albums = array();
	foreach ($album_list as $album) {
		if ($album['visible']) {
			$visible_albums[] = $album;
		}
	}
    return $visible_albums;
}







function zeroise($number,$threshold)
{ // function to add leading zeros when necessary
  // taken from wordpress

	$l=strlen($number);
	if ($l<$threshold)
		for ($i=0; $i<($threshold-$l); $i=$i+1) { $number='0'.$number;	}
	return $number;
}








function smarty_modifier_truncate($string, $length = 80, $etc = '...',
                                  $break_words = false)
{ // taken from smarty
    if ($length == 0)
        return '';

    if (strlen($string) > $length) {
        $length -= strlen($etc);
        if (!$break_words)
            $string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));
      
        return substr($string, 0, $length).$etc;
    } else
        return $string;
}










function get_cover_id($album_sanitized_name)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db;

    $db->open($path_db.$db_albums, 0);
    $album = $db->select('sanitized_name', $album_sanitized_name);
    $db->close();

    // cover image // working 2004-02-12 22:51:42
    $db->open($path_db.$db_photos, 0);
    $photos = $db->select('album_id', $album[0]['id']);

    if (strlen($album[0]['cover_image']) > 0) {
        $verify_cover = $db->select('id', $album[0]['cover_image']);
        if (  $verify_cover[0]['visible'] == 1 && $verify_cover[0]['album_id'] == $album[0]['cover_image']  ) {
            $img_id = $album[0]['cover_image'];
        } else {
            if (count($photos) == 1) {
                $img_id = $photos[0]['id'];
            } else {
                $photos = show_visible($photos);
                //$db->sort_by_column($photos, 'sort_order');
                $photos = $db->order_by($photos, 'sort_order');
                $img_id = $photos[0]['id'];
            }
        }
    } else {
        if (count($photos) == 1) {
            $img_id = $photos[0]['id'];
        } else {
            $photos = show_visible($photos);
            //$db->sort_by_column($photos, 'sort_order');
            $photos = $db->order_by($photos, 'sort_order');
            $img_id = $photos[0]['id'];
        }
    }
    $db->close();
    return $img_id;
}






/* 

$thumb = used to get orig filename, or thumbnail filename
*/
function get_cover_image($album_sanitized_name, $thumb = true)
{
    global $db, $gallery_url, $db_albums, $db_photos, $db_uploads, $thumbnail_prefix, $path_db, $path_photos;

    if ($thumb) {
    	$pre = $thumbnail_prefix;
    } else {
    	$pre = '';
    }

    $db->open($path_db.$db_albums, 0);
    $album = $db->select('sanitized_name', $album_sanitized_name);
    $db->close();


    if (strlen($album[0]['cover_image']) > 0) {
        $db->open($path_db.$db_photos, 0);
        $cover = $db->select('id', $album[0]['cover_image']);
        $db->close();
        $db->open($path_db.$db_uploads, 0);
        $img = $db->select('id', $cover[0]['upload_id']);
        $db->close();
        $cover_image = $gallery_url.$path_photos.$pre.$img[0]['filename'];
    } else {
        $db->open($path_db.$db_photos, 0);
        $photos = $db->select('album_id', $album[0]['id']);
        if (count($photos) == 1) {
            $db->close();
            $db->open($path_db.$db_uploads, 0);
            $img = $db->select('id', $photos[0]['upload_id']);
            $db->close();
            $cover_image = $gallery_url.$path_photos.$pre.$img[0]['filename'];
        } else {
            //$db->sort_by_column($photos, 'sort_order');
            $photos = $db->order_by($photos, 'sort_order');
            $db->close();
            $db->open($path_db.$db_uploads, 0);
            $img = $db->select('id', $photos[0]['upload_id']);
            $db->close();
            $cover_image = $gallery_url.$path_photos.$pre.$img[0]['filename'];
        }
    }
    return $cover_image;
}





function count_photos_for_album($album_id, $visible_only = true)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db;

    $db->open($path_db.$db_photos, 0);
    $photos = $db->select('album_id', $album_id);
    $db->close();

    if ($visible_only) {
        $photos = show_visible($photos);
    }

    return count($photos);
}







/* ==========================================
    template function
 ========================================== */
function get_album_list()
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db;


    $db->open($path_db.$db_albums, 0);
    $album_list = $db->get_all();
    $db->close();

    //$db->sort_by_column($album_list, 'sort_order');
    $album_list = $db->order_by($album_list, 'sort_order', 'DESC');
    $album_list = show_visible($album_list);
    //$album_list = show_toplevel($album_list);

    for ($i=0; $i < count($album_list); $i++) {
        $album_list[$i]['title_raw'] = $album_list[$i]['title'];
        $album_list[$i]['title_nohtml'] = wptexturize(strip_tags($album_list[$i]['title']));
        $album_list[$i]['title'] = wptexturize($album_list[$i]['title']);
        $album_list[$i]['description_excerpt_nohtml'] = smarty_modifier_truncate(wptexturize(strip_tags($album_list[$i]['description'])), 50);
        $album_list[$i]['description_raw'] = $album_list[$i]['description'];
        $album_list[$i]['description_nohtml'] = wptexturize(strip_tags($album_list[$i]['description']));
        $album_list[$i]['description'] = wpautop(wptexturize($album_list[$i]['description']));
        $album_list[$i]['date_edited'] = date($gallery_date_format,  strtotime($album_list[$i]['date_edited']));
        $album_list[$i]['date_created'] = date($gallery_date_format,  strtotime($album_list[$i]['date_created']));
        $album_list[$i]['cover_image_thumbnail'] = get_cover_image($album_list[$i]['sanitized_name']);
        $album_list[$i]['cover_image'] = get_cover_image($album_list[$i]['sanitized_name'], 0);
        $album_list[$i]['photo_count'] = count_photos_for_album($album_list[$i]['id']);
        if ($use_mod_rewrite) {
            $album_list[$i]['link'] = $gallery_url.$album_list[$i]['sanitized_name'].'/';
        } else {
            $album_list[$i]['link'] = $gallery_url.'?a='.$album_list[$i]['sanitized_name'];
        }

        // unset unused tags
        unset($album_list[$i]['visible']);
        unset($album_list[$i]['sort_order']);
        //unset($album_list[$i]['id']); added for unique CSS ID

    }

    return $album_list;
}











/* ==========================================
    template function
    $internal_use = used in get_current_photo()
 ========================================== */
function get_thumbnail_list($album_sanitized_name, $internal_use = false)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $thumbnail_prefix, $path_db, $path_photos, $url_zeroise;

    $db->open($path_db.$db_albums, 0);
    $album = $db->select('sanitized_name', $album_sanitized_name);
    $db->close();


    $db->open($path_db.$db_photos, 0);
    $photos = $db->select('album_id', $album[0]['id']);
    $db->close();


    //$db->sort_by_column($photos, 'sort_order');
    $photos = $db->order_by($photos, 'sort_order');
    $photos = show_visible($photos); // all photos for the album


    $db->open($path_db.$db_uploads, 0);
    for ($i=0; $i < count($photos); $i++) {
        unset($res);
        $res = $db->select('id', $photos[$i]['upload_id']);
        $photos[$i]['filename'] = $res[0]['filename'];
        $photos[$i]['thumbnail'] = $res[0]['thumbnail'];
        $photos[$i]['width'] = $res[0]['width'];
        $photos[$i]['height'] = $res[0]['height'];
        $photos[$i]['date_uploaded'] = $res[0]['date_uploaded'];
        $photos[$i]['image'] = $gallery_url.$path_photos.$thumbnail_prefix.$photos[$i]['filename'];


        if ($use_mod_rewrite) {
            $photos[$i]['link'] = $gallery_url.$album_sanitized_name.'/'.zeroise($photos[$i]['id'], $url_zeroise).'/';
        } else {
            $photos[$i]['link'] = $gallery_url.'?a='.$album_sanitized_name.'&amp;i='.$photos[$i]['id'];
        }

        $photos[$i]['title_raw'] = $photos[$i]['title'];
        $photos[$i]['title_nohtml'] = wptexturize(strip_tags($photos[$i]['title']));
        $photos[$i]['title'] = wptexturize($photos[$i]['title']);
        $photos[$i]['caption_excerpt_nohtml'] = smarty_modifier_truncate(wptexturize(strip_tags($photos[$i]['caption'])), 50);
        $photos[$i]['caption_raw'] = $photos[$i]['caption'];
        $photos[$i]['caption_nohtml'] = wptexturize(strip_tags($photos[$i]['caption']));
        $photos[$i]['caption'] = wpautop(wptexturize($photos[$i]['caption']));
        $photos[$i]['date_taken'] = date($gallery_date_format,  strtotime($photos[$i]['date_taken']));;
        $photos[$i]['date_edited'] = date($gallery_date_format,  strtotime($photos[$i]['date_edited']));;
        $photos[$i]['date_created'] = date($gallery_date_format,  strtotime($photos[$i]['date_created']));;

    
        if (!$internal_use) {
            // unset unused tags
            unset($photos[$i]['visible']);
            unset($photos[$i]['sort_order']);
            //unset($photos[$i]['id']); // added, used for unique ID in CSS
            unset($photos[$i]['upload_id']);
            unset($photos[$i]['album_id']);
            unset($photos[$i]['filename']);
            unset($photos[$i]['date_uploaded']);
            unset($photos[$i]['thumbnail']);
            unset($photos[$i]['width']);
            unset($photos[$i]['height']);
        }
    
    }
    $db->close();




    return $photos;

}











function get_current_photo($album_sanitized_name, $img_id)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_photos;

    $current_photo = array();



    $photos = get_thumbnail_list($album_sanitized_name, 1);

    $found = 0;
    for ($i=0; $i < count($photos); $i++) {
        if ($photos[$i]['id'] == $img_id) {
            $found = 1;

            $current_photo = $photos[$i];



            if (isset($photos[$i+1])) {
                $current_photo['next_link'] = $photos[$i+1]['link'];
                $current_photo['next_image_thumbnail'] = $photos[$i+1]['image'];
                $current_photo['next_title_raw'] = $photos[$i+1]['title_raw'];
                $current_photo['next_title_nohtml'] = $photos[$i+1]['title_nohtml'];
                $current_photo['next_title'] = $photos[$i+1]['title'];
                $current_photo['next_caption_excerpt_nohtml'] = $photos[$i+1]['caption_excerpt_nohtml'];
                $current_photo['next_caption_raw'] = $photos[$i+1]['caption_raw'];
                $current_photo['next_caption_nohtml'] = $photos[$i+1]['caption_nohtml'];
                $current_photo['next_caption'] = $photos[$i+1]['caption'];
            }
            if (isset($photos[$i-1])) {
                $current_photo['prev_link'] = $photos[$i-1]['link'];
                $current_photo['prev_image_thumbnail'] = $photos[$i-1]['image'];
                $current_photo['prev_title_raw'] = $photos[$i-1]['title_raw'];
                $current_photo['prev_title_nohtml'] = $photos[$i-1]['title_nohtml'];
                $current_photo['prev_title'] = $photos[$i-1]['title'];
                $current_photo['prev_caption_excerpt_nohtml'] = $photos[$i-1]['caption_excerpt_nohtml'];
                $current_photo['prev_caption_raw'] = $photos[$i-1]['caption_raw'];
                $current_photo['prev_caption_nohtml'] = $photos[$i-1]['caption_nohtml'];
                $current_photo['prev_caption'] = $photos[$i-1]['caption'];               
            }



            $current_photo['filesize_kb'] = round(filesize($path_photos.$photos[$i]['filename'])/1024, 2);
            $current_photo['image'] = $gallery_url.$path_photos.$photos[$i]['filename'];
            $current_photo['permalink'] = $photos[$i]['link'];



            // remove unused tags
            //unset($current_photo['id']); added again for CSS unique ID
            unset($current_photo['upload_id']);
            unset($current_photo['album_id']);
            unset($current_photo['sort_order']);
            unset($current_photo['filename']);
            unset($current_photo['thumbnail']);
            unset($current_photo['date_uploaded']);
            unset($current_photo['visible']);
            //unset($current_photo['link']);


            break;
        }
    }

    if (!$found) {
    	return 0;
    } else {
        return $current_photo;
    }
}












function get_album_info($album_sanitized_name)
{
    global $db, $use_mod_rewrite, $gallery_url, $gallery_date_format, $db_albums, $db_photos, $db_uploads, $path_db;

    $db->open($path_db.$db_albums, 0);
    $album = $db->select('sanitized_name', $album_sanitized_name);
    $db->close();

    $album[0]['title_raw'] = $album[0]['title'];
    $album[0]['title_nohtml'] = wptexturize(strip_tags($album[0]['title']));
    $album[0]['title'] = wptexturize($album[0]['title']);
    $album[0]['description_excerpt_nohtml'] = smarty_modifier_truncate(wptexturize(strip_tags($album[0]['description'])), 50);
    $album[0]['description_raw'] = $album[0]['description'];
    $album[0]['description_nohtml'] = wptexturize(strip_tags($album[0]['description']));
    $album[0]['description'] = wpautop(wptexturize($album[0]['description']));
    $album[0]['date_edited'] = date($gallery_date_format,  strtotime($album[0]['date_edited']));
    $album[0]['date_created'] = date($gallery_date_format,  strtotime($album[0]['date_created']));
    $album[0]['cover_image_thumbnail'] = get_cover_image($album_sanitized_name);
    $album[0]['cover_image'] = get_cover_image($album_sanitized_name, 0);
    $album[0]['photo_count'] = count_photos_for_album($album[0]['id']);

    if ($use_mod_rewrite) {
        $album[0]['link'] = $gallery_url.$album[0]['sanitized_name'].'/';
    } else {
        $album[0]['link'] = $gallery_url.'?a='.$album[0]['sanitized_name'];
    }

    $album[0]['permalink'] = $album[0]['link'];
    // remove unused keys
    //unset($album[0]['id']); add for CSS ID
    unset($album[0]['sort_order']);
    unset($album[0]['visible']);

    return $album[0];
}









function set_edit_time($album_id)
{
    global $db, $server_time_offset, $db_albums, $db_photos, $db_uploads, $path_db;

    $db->open('../'.$path_db.$db_albums, 1);
    $update['date_edited'] = date('Y-m-d H:i:s', time() + (3600 * $server_time_offset));
    $db->update('id', $album_id, $update);
    $db->close();

    return true;
}








function microtime_diff($a, $b, $precision = 4) {
     list($a_micro, $a_int)=explode(' ',$a);
     list($b_micro, $b_int)=explode(' ',$b);
     if ($a_int>$b_int) {
        $val = ($a_int-$b_int)+($a_micro-$b_micro);
     } elseif ($a_int==$b_int) {
        if ($a_micro>$b_micro) {
           $val = ($a_int-$b_int)+($a_micro-$b_micro);
        } elseif ($a_micro<$b_micro) {
           $val = ($b_int-$a_int)+($b_micro-$a_micro);
        } else {
           $val = 0;
        }
     } else { // $a_int<$b_int
        $val = ($b_int-$a_int)+($b_micro-$a_micro);
     }
    return round($val, $precision);
}





?>